Index: cgicc/ChangeLog
diff -c cgicc/ChangeLog:1.2 cgicc/ChangeLog:1.5
*** cgicc/ChangeLog:1.2	Fri May 14 11:29:26 1999
--- cgicc/ChangeLog	Wed Jun  2 15:20:26 1999
***************
*** 1,5 ****
! 1999-05-14  Stephen Booth       <sbooth@saaba.lmi.net>
  
  	* Removed classes LinkedList and Iterator
  	* Reworked to use the STL classes vector, iterator, and string
  	* Changed include directory from $(includedir) to $(pkgincludedir)
--- 1,38 ----
! 1999-06-02  Stephen F. Booth  <sbooth@saaba.lmi.net>
  
+ 	* configure.in: Added AM_MAINTAINER_MODE, and switched order
+ 	of the AC_ENABLE for demos and namespaces (to reflect relative
+ 	importance).
+ 	* Makefile.am: Added maintainer mode conditional around
+ 	cvs-dist and cvs-diff targets.
+ 	* info/Makefile.am: Added maintainer mode targets doc-gz,
+ 	doc-texi-gz, doc-info-gz, doc-dvi-gz (for generating
+ 	.tar.gz files for web documentation)
+ 	* src/Makefile.am: Updated version info to 0:1:0
+ 	* Upgraded to libtool-1.3.2
+ 
+ 1999-06-01  Stephen F. Booth  <sbooth@saaba..lmi.net>
+ 
+ 	* src/CgiUtils.cc(readString): Added STDNS macro in front of
+ 	instantiated string object.
+ 	* src/Cgicc.cc(findEntries): Added block for MS C++ compilers
+ 	on Win32 that don't support the std::copy_if function.
+ 	* src/HTTPHeaders.cc(render): Added STDNS macro in front of
+ 	endl (all render methods).
+ 	* src/CgiEnvironment.cc(CgiEnvironment): Added STDNS macro in
+ 	front of cin.
+ 	* src/CgiEnvironment.cc(save,restore): Added STDNS macro in front
+ 	of ios::in and ios::skipws.
+ 	* info/reporting-bugs.texinfo: Added file
+ 	* info/cgicc.texinfo: Now includes section on reporting bugs
+ 
+ 1999-05-31  Stephen F. Booth  <sbooth@saaba.lmi.net>
+ 
+ 	* src/CgiUtils.cc(unescapeString): Added temporary to ensure
+ 	evaluation order of iterator increment in call to hexToChar.
+ 
+ 1999-05-14  Stephen F. Booth  <sbooth@saaba.lmi.net>
+ 
  	* Removed classes LinkedList and Iterator
  	* Reworked to use the STL classes vector, iterator, and string
  	* Changed include directory from $(includedir) to $(pkgincludedir)
***************
*** 8,20 ****
  	* Added methods on Cgicc for querying the system type
  	* Released as part of the GNU project under the GPL
  
! 1999-01-05  Stephen Booth       <sbooth@saaba.lmi.net>
  
  	* Fixed problem in src/Makefile.am that caused config.h to 
  	not be installed
  	* Added example/ directory containing a skeleton CGI and Makefile
  	
! 1998-12-11  Stephen Booth	<sbooth@saaba.lmi.net>
  
  	* Reworked to use autoconf/automake/libtool
  	* Re-released under the GNU Library General Public License
--- 41,53 ----
  	* Added methods on Cgicc for querying the system type
  	* Released as part of the GNU project under the GPL
  
! 1999-01-05  Stephen F. Booth  <sbooth@saaba.lmi.net>
  
  	* Fixed problem in src/Makefile.am that caused config.h to 
  	not be installed
  	* Added example/ directory containing a skeleton CGI and Makefile
  	
! 1998-12-11  Stephen F. Booth  <sbooth@saaba.lmi.net>
  
  	* Reworked to use autoconf/automake/libtool
  	* Re-released under the GNU Library General Public License
Index: cgicc/Makefile.am
diff -c cgicc/Makefile.am:1.12 cgicc/Makefile.am:1.13
*** cgicc/Makefile.am:1.12	Fri May 14 14:33:54 1999
--- cgicc/Makefile.am	Wed Jun  2 15:08:36 1999
***************
*** 1,4 ****
! ## $Id: Makefile.am,v 1.12 1999/05/14 21:33:54 sbooth Exp $
  
  if DEMOS
  DEMO = demo
--- 1,4 ----
! ## $Id: Makefile.am,v 1.13 1999/06/02 22:08:36 sbooth Exp $
  
  if DEMOS
  DEMO = demo
***************
*** 18,23 ****
--- 18,24 ----
  	cp -p $(srcdir)/example/Makefile.in $(distdir)/example
  	cp -p $(srcdir)/example/yourSource.cc $(distdir)/example
  
+ if MAINTAINER_MODE
  ################################################################
  ##
  ## Everything past here is useful to the maintainer, but probably not
***************
*** 27,36 ****
  ## set it to `:' to avoid CVS operations
  CVS = cvs
  
! ## Tag before making distribution.  Also, don't make a distribution if
! ## checks fail.  Also, make sure the NEWS file is up-to-date.
  cvs-dist: distcheck
! 	@if sed '1,9d;10q' $(srcdir)/NEWS | grep -e "$(VERSION)" > /dev/null; then :; else \
  	  echo "NEWS not updated; not releasing" 1>&2; \
  	  exit 1;				\
  	fi
--- 28,39 ----
  ## set it to `:' to avoid CVS operations
  CVS = cvs
  
! ## Tag sources before making distribution, but don't make a
! ## distribution if checks fail.  Also, make sure the NEWS file is
! ## up-to-date.
  cvs-dist: distcheck
! 	@if sed '1,9d;10q' $(srcdir)/NEWS | grep -e "$(VERSION)" > /dev/null; \
! 	then :; else \
  	  echo "NEWS not updated; not releasing" 1>&2; \
  	  exit 1;				\
  	fi
***************
*** 38,43 ****
--- 41,48 ----
  	 $(CVS) -q tag `echo "release-$(VERSION)" | sed 's/\./-/g'`
  	$(MAKE) dist
  
+ ## Generate a context diff file containing the patch info for the
+ ## current version.
  cvs-diff:
  	thisver=`echo "release-$(VERSION)" | sed 's/\./-/g'`; \
  	if test -z "$$OLDVERSION"; then \
***************
*** 46,49 ****
  	prevver=release-`echo $$prevno | sed 's/\./-/g'`; \
  	$(CVS) -f rdiff -c -r $$prevver -r $$thisver $(PACKAGE) \
  	    > $(PACKAGE)-$$prevno-$(VERSION).diff
! 
--- 51,54 ----
  	prevver=release-`echo $$prevno | sed 's/\./-/g'`; \
  	$(CVS) -f rdiff -c -r $$prevver -r $$thisver $(PACKAGE) \
  	    > $(PACKAGE)-$$prevno-$(VERSION).diff
! endif
Index: cgicc/NEWS
diff -c cgicc/NEWS:1.5 cgicc/NEWS:1.6
*** cgicc/NEWS:1.5	Fri May 14 14:31:36 1999
--- cgicc/NEWS	Tue Jun  1 14:24:55 1999
***************
*** 7,12 ****
--- 7,18 ----
  
  ======================================================================
  
+         Major changes between versions 2.2.3 and 3.0.1
+ 
+ * Various fixes for namespace support, submitted by Bob Kline.
+ 
+ * Updated documentation regarding Cgicc mailing lists.
+ 
          Major changes between versions 2.2.3 and 3.0
  
  * Reworked to use the C++ standard template library. 
Index: cgicc/README
diff -c cgicc/README:1.5 cgicc/README:1.6
*** cgicc/README:1.5	Wed May 12 10:16:16 1999
--- cgicc/README	Tue Jun  1 14:21:21 1999
***************
*** 17,25 ****
  Please send bug reports, suggestions, and comments to
  <bug-cgicc@gnu.org>
  
! There is a Cgicc mailing list at <cgicc@gnu.org>.  
! To subscribe, send a message to <cgicc-request@gnu.org> with the word
! "subscribe" in the subject field.
  
  This package should contain the following directories:
  
--- 17,24 ----
  Please send bug reports, suggestions, and comments to
  <bug-cgicc@gnu.org>
  
! To subscribe, send a message to <bug-cgicc-request@gnu.org> with the
! word "subscribe" in the subject field.
  
  This package should contain the following directories:
  
Index: cgicc/acconfig.h
diff -c cgicc/acconfig.h:1.2 cgicc/acconfig.h:1.3
*** cgicc/acconfig.h:1.2	Mon Apr 26 15:41:54 1999
--- cgicc/acconfig.h	Wed May 26 10:09:55 1999
***************
*** 1,5 ****
  /*
!  *  $Id: acconfig.h,v 1.2 1999/04/26 22:41:54 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: acconfig.h,v 1.3 1999/05/26 17:09:55 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,24 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ @TOP@
  
  /* Name of package. */
  #undef PACKAGE
Index: cgicc/configure.in
diff -c cgicc/configure.in:1.11 cgicc/configure.in:1.13
*** cgicc/configure.in:1.11	Thu May 13 10:37:38 1999
--- cgicc/configure.in	Wed Jun  2 15:08:14 1999
***************
*** 1,9 ****
! dnl $Id: configure.in,v 1.11 1999/05/13 17:37:38 sbooth Exp $
  
  dnl Process this file with autoconf to produce a configure script.
  AC_INIT(src/Cgicc.cc)
! AM_INIT_AUTOMAKE(cgicc, 3.0)
  AM_CONFIG_HEADER(src/config.h)
  
  AC_LANG_CPLUSPLUS
  
--- 1,10 ----
! dnl $Id: configure.in,v 1.13 1999/06/02 22:08:14 sbooth Exp $
  
  dnl Process this file with autoconf to produce a configure script.
  AC_INIT(src/Cgicc.cc)
! AM_INIT_AUTOMAKE(cgicc, 3.0.1)
  AM_CONFIG_HEADER(src/config.h)
+ AM_MAINTAINER_MODE
  
  AC_LANG_CPLUSPLUS
  
***************
*** 42,58 ****
  AC_HEADER_TIME
  AC_CHECK_FUNCS(strftime gettimeofday uname)
  
- dnl enable/disable the demos, if specified
- AC_ARG_ENABLE(demos, 
- 	[  --enable-demos          build demos [default=yes]],
- 	[case "${enableval}" in
- 		yes) demos=true ;;
- 		no)  demos=false ;;
- 		*) AC_MSG_ERROR(bad value ${enableval} for --enable-demos) ;;
- 		esac], 
- 	demos=true)
- AM_CONDITIONAL(DEMOS, test "$demos" = true)
- 
  dnl enable/disable namespaces, if specified
  AC_ARG_ENABLE(namespaces,
  	[  --enable-namespaces     enable namespace support [default=yes]],
--- 43,48 ----
***************
*** 67,72 ****
--- 57,74 ----
  else
  	AC_DEFINE(USE_NAMESPACES, 0)
  fi
+ 
+ 
+ dnl enable/disable the demos, if specified
+ AC_ARG_ENABLE(demos, 
+ 	[  --enable-demos          build demos [default=yes]],
+ 	[case "${enableval}" in
+ 		yes) demos=true ;;
+ 		no)  demos=false ;;
+ 		*) AC_MSG_ERROR(bad value ${enableval} for --enable-demos) ;;
+ 		esac], 
+ 	demos=true)
+ AM_CONDITIONAL(DEMOS, test "$demos" = true)
  
  AC_OUTPUT([Makefile src/Makefile info/Makefile demo/Makefile example/Makefile])
  
Index: cgicc/demo/test.cc
diff -c cgicc/demo/test.cc:1.4 cgicc/demo/test.cc:1.6
*** cgicc/demo/test.cc:1.4	Tue May 11 10:03:43 1999
--- cgicc/demo/test.cc	Tue Jun  1 12:34:56 1999
***************
*** 1,5 ****
  /*
!  *  $Id: test.cc,v 1.4 1999/05/11 17:03:43 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: test.cc,v 1.6 1999/06/01 19:34:56 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 128,134 ****
      cout << comment() << "This page generated by Cgicc for "
  	 << env.getRemoteHost() << comment() << endl;
      cout << h4() << "Thanks for using Cgi" << span("cc", add("class", "red")) 
! 	 << ", " << env.getRemoteHost() << '!' << h4() << endl;  
      
      // If the user wants to save the submission, do it
      if(cgi.queryCheckbox("save")) {
--- 128,135 ----
      cout << comment() << "This page generated by Cgicc for "
  	 << env.getRemoteHost() << comment() << endl;
      cout << h4() << "Thanks for using Cgi" << span("cc", add("class", "red")) 
! 	 << ", " << env.getRemoteHost() 
! 	 << '(' << env.getRemoteAddr() << ")!" << h4() << endl;  
      
      // If the user wants to save the submission, do it
      if(cgi.queryCheckbox("save")) {
***************
*** 185,191 ****
      
      // Information on Cgicc
      cout << CGICCNS div(add("align","center").add("class","smaller")) << endl;
!     cout << "Cgi" << span("cc", add("class","red")) << " v";
      cout << cgi.getVersion();
      cout << " by " << a("Stephen F. Booth", 
  			add("href", "http://www.lmi.net/~sbooth/")) 
--- 186,192 ----
      
      // Information on Cgicc
      cout << CGICCNS div(add("align","center").add("class","smaller")) << endl;
!     cout << "GNU Cgi" << span("cc", add("class","red")) << " v";
      cout << cgi.getVersion();
      cout << " by " << a("Stephen F. Booth", 
  			add("href", "http://www.lmi.net/~sbooth/")) 
Index: cgicc/info/Makefile.am
diff -c cgicc/info/Makefile.am:1.1 cgicc/info/Makefile.am:1.3
*** cgicc/info/Makefile.am:1.1	Mon Apr 26 15:48:09 1999
--- cgicc/info/Makefile.am	Wed Jun  2 15:07:34 1999
***************
*** 1,11 ****
! ## $Id: Makefile.am,v 1.1 1999/04/26 22:48:09 sbooth Exp $
  
  CLEANFILES = *~
  
  info_TEXINFOS = cgicc.texinfo
! cgicc_TEXINFOS = gpl.texinfo cgi-overview.texinfo tutorial.texinfo \
! library-overview.texinfo cgi-classes.texinfo \
! http-classes.texinfo html-classes.texinfo \
! class-cgicc.texinfo class-cgienv.texinfo class-formentry.texinfo \
! class-formfile.texinfo classes-http.texinfo classes-html.texinfo \
! concept-index.texinfo function-index.texinfo datatype-index.texinfo
--- 1,36 ----
! ## $Id: Makefile.am,v 1.3 1999/06/02 22:07:34 sbooth Exp $
  
  CLEANFILES = *~
+ MAINTAINERCLEANFILES = cgicc-doc-texi.tar.gz cgicc-doc-info.tar.gz	\
+ cgicc-doc-dvi.tar.gz
  
  info_TEXINFOS = cgicc.texinfo
! cgicc_TEXINFOS = gpl.texinfo cgi-overview.texinfo tutorial.texinfo	\
! library-overview.texinfo cgi-classes.texinfo http-classes.texinfo	\
! html-classes.texinfo class-cgicc.texinfo class-cgienv.texinfo		\
! class-formentry.texinfo class-formfile.texinfo classes-http.texinfo	\
! classes-html.texinfo reporting-bugs.texinfo concept-index.texinfo	\
! function-index.texinfo datatype-index.texinfo
! 
! if MAINTAINER_MODE
! ################################################################
! ##
! ## Everything past here is useful to the maintainer, but probably not
! ## to anybody else.
! ##
! 
! doc-gz: doc-texi-gz doc-info-gz doc-dvi-gz
! 
! doc-texi-gz: 
! 	-rm -f cgicc-doc-texi.tar.gz
! 	GZIP=$(GZIP_ENV) $(TAR) chozf cgicc-doc-texi.tar.gz *.texi*
! 
! doc-info-gz: info
! 	-rm -f cgicc-doc-info.tar.gz
! 	GZIP=$(GZIP_ENV) $(TAR) chozf cgicc-doc-info.tar.gz *.info*
! 
! doc-dvi-gz: dvi
! 	-rm -f cgicc-doc-dvi.tar.gz
! 	GZIP=$(GZIP_ENV) $(TAR) chozf cgicc-doc-dvi.tar.gz $(DVIS)
! 
! endif
Index: cgicc/info/cgicc.texinfo
diff -c cgicc/info/cgicc.texinfo:1.2 cgicc/info/cgicc.texinfo:1.5
*** cgicc/info/cgicc.texinfo:1.2	Fri May 14 10:57:41 1999
--- cgicc/info/cgicc.texinfo	Tue Jun  1 14:19:34 1999
***************
*** 69,74 ****
--- 69,75 ----
  approved by the Free Software Foundation.
  @end titlepage
  
+ @c @ifnottex
  @ifinfo
  @node Top, Overview of CGI, (dir), (dir)
  @top Cgicc
***************
*** 80,85 ****
--- 81,87 ----
  applications for the World Wide Web (WWW).
  
  This is Edition @value{EDITION} of the Cgicc documentation, @value{UPDATED}.
+ @c @end ifnottex
  @end ifinfo
  
  @menu
***************
*** 95,100 ****
--- 97,103 ----
  * class FormFile::              Represents a file uploaded via HTTP
  * classes for HTTP headers::    Used for generating response information
  * classes for HTML output::     Used for generating a client response
+ * Reporting Bugs::              How to report a bug in Cgicc
  * Copying::                     Your rights to distribute Cgicc
  * Concept Index::               Index of concepts introduced in the manual
  * Function Index::              Index of member functions
***************
*** 102,107 ****
--- 105,111 ----
  
  
  
+ 
  @end menu
  
  @include cgi-overview.texinfo
***************
*** 116,121 ****
--- 120,126 ----
  @include class-formfile.texinfo
  @include classes-http.texinfo
  @include classes-html.texinfo
+ @include reporting-bugs.texinfo
  @include gpl.texinfo
  @include concept-index.texinfo
  @include function-index.texinfo
Index: cgicc/info/classes-html.texinfo
diff -c cgicc/info/classes-html.texinfo:1.3 cgicc/info/classes-html.texinfo:1.4
*** cgicc/info/classes-html.texinfo:1.3	Fri May 14 10:57:42 1999
--- cgicc/info/classes-html.texinfo	Tue Jun  1 14:19:34 1999
***************
*** 1,5 ****
  @comment -*-texinfo-*-
! @node classes for HTML output, Copying, classes for HTTP headers, Top
  @unnumbered classes for HTML output
  
  For an introduction to Cgicc's HTML output, please see @xref{A tutorial
--- 1,5 ----
  @comment -*-texinfo-*-
! @node classes for HTML output, Reporting Bugs, classes for HTTP headers, Top
  @unnumbered classes for HTML output
  
  For an introduction to Cgicc's HTML output, please see @xref{A tutorial
Index: cgicc/info/gpl.texinfo
diff -c cgicc/info/gpl.texinfo:1.1 cgicc/info/gpl.texinfo:1.2
*** cgicc/info/gpl.texinfo:1.1	Mon Apr 26 15:48:13 1999
--- cgicc/info/gpl.texinfo	Tue Jun  1 14:19:34 1999
***************
*** 1,5 ****
  @comment -*-texinfo-*-
! @node Copying, Concept Index, classes for HTML output, Top
  @appendix GNU General Public License
  
  @center Version 2, June 1991
--- 1,5 ----
  @comment -*-texinfo-*-
! @node Copying, Concept Index, Reporting Bugs, Top
  @appendix GNU General Public License
  
  @center Version 2, June 1991
Index: cgicc/info/reporting-bugs.texinfo
diff -c /dev/null cgicc/info/reporting-bugs.texinfo:1.1
*** /dev/null	Wed Jun  2 15:40:26 1999
--- cgicc/info/reporting-bugs.texinfo	Tue Jun  1 14:19:34 1999
***************
*** 0 ****
--- 1,16 ----
+ @comment -*-texinfo-*-
+ @node Reporting Bugs, Copying, classes for HTML output, Top
+ @unnumbered Reporting Bugs
+ 
+ There is a mailing list for reporting bugs, @email{bug-cgicc@@gnu.org},
+ to enable the developers to track submitted bug reports.
+ 
+ If you think you have found a bug in Cgicc, then you should send as
+ complete a report as possible to this list. Ideally, you should include
+ the text you get by running @code{config.guess}, the text you see when
+ you run @code{configure}, and if you can, a patch made with @code{diff
+ -u5} which fixes the problem. 
+ 
+ If you wish to subscribe to this list, send empty mail with a
+ @code{Subject:} line of @code{subscribe} to
+ @email{bug-cgicc-request@@gnu.org}.
Index: cgicc/info/version.texi
diff -c cgicc/info/version.texi:1.6 cgicc/info/version.texi:1.8
*** cgicc/info/version.texi:1.6	Fri May 14 10:57:42 1999
--- cgicc/info/version.texi	Tue Jun  1 14:19:57 1999
***************
*** 1,3 ****
! @set UPDATED 14 May 1999
! @set EDITION 3.0
! @set VERSION 3.0
--- 1,3 ----
! @set UPDATED 1 June 1999
! @set EDITION 3.0.1
! @set VERSION 3.0.1
Index: cgicc/src/CgiDefs.hh
diff -c cgicc/src/CgiDefs.hh:1.7 cgicc/src/CgiDefs.hh:1.10
*** cgicc/src/CgiDefs.hh:1.7	Mon Apr 26 15:42:23 1999
--- cgicc/src/CgiDefs.hh	Fri May 28 12:37:11 1999
***************
*** 1,5 ****
  /*
!  *  $Id: CgiDefs.hh,v 1.7 1999/04/26 22:42:23 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: CgiDefs.hh,v 1.10 1999/05/28 19:37:11 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,25 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __CGI_DEFS__
! #define __CGI_DEFS__ 1
  
  #if HAVE_CONFIG_H
  #include "config.h"
--- 18,25 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _CGIDEFS_HH_
! #define _CGIDEFS_HH_ 1
  
  #if HAVE_CONFIG_H
  #include "config.h"
***************
*** 38,41 ****
  #define STDNS 
  #endif
  
! #endif
--- 38,41 ----
  #define STDNS 
  #endif
  
! #endif /* ! _CGIDEFS_HH_ */
Index: cgicc/src/CgiEnvironment.cc
diff -c cgicc/src/CgiEnvironment.cc:1.9 cgicc/src/CgiEnvironment.cc:1.11
*** cgicc/src/CgiEnvironment.cc:1.9	Tue May 11 10:03:47 1999
--- cgicc/src/CgiEnvironment.cc	Tue Jun  1 10:10:18 1999
***************
*** 1,5 ****
  /*
!  *  $Id: CgiEnvironment.cc,v 1.9 1999/05/11 17:03:47 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: CgiEnvironment.cc,v 1.11 1999/06/01 17:10:18 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,23 ****
--- 18,27 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
+ 
  #include <new>
  #include <memory>
  #include <stdexcept>
***************
*** 42,49 ****
      // should work, but not in egcs-1.1.2
      //auto_ptr<char> temp = new char[getContentLength()];
      char *temp = new char[getContentLength()];
!     cin.read(temp, getContentLength());
!     if(cin.gcount() != getContentLength()) {
        delete [] temp;
        throw STDNS runtime_error("I/O error");
      }
--- 46,53 ----
      // should work, but not in egcs-1.1.2
      //auto_ptr<char> temp = new char[getContentLength()];
      char *temp = new char[getContentLength()];
!     STDNS cin.read(temp, getContentLength());
!     if(STDNS cin.gcount() != getContentLength()) {
        delete [] temp;
        throw STDNS runtime_error("I/O error");
      }
***************
*** 146,152 ****
  CGICCNS CgiEnvironment::save(const STDNS string& filename) 	const
  {
    LOGLN("CgiEnvironment::save")
!   STDNS ofstream file( filename.c_str(), ios::out );
  
    if( ! file )
      throw STDNS runtime_error("I/O error");
--- 150,156 ----
  CGICCNS CgiEnvironment::save(const STDNS string& filename) 	const
  {
    LOGLN("CgiEnvironment::save")
!   STDNS ofstream file( filename.c_str(), STDNS ios::out );
  
    if( ! file )
      throw STDNS runtime_error("I/O error");
***************
*** 190,201 ****
  CGICCNS CgiEnvironment::restore(const STDNS string& filename)
  {
    LOGLN("CgiEnvironment::restore()")
!   STDNS ifstream file( filename.c_str(), ios::in );
  
    if( ! file )
      throw STDNS runtime_error("I/O error");
  
!   file.flags(file.flags() & ios::skipws);
  
    fContentLength 	= readLong(file);
    fServerPort 		= readLong(file);
--- 194,205 ----
  CGICCNS CgiEnvironment::restore(const STDNS string& filename)
  {
    LOGLN("CgiEnvironment::restore()")
!   STDNS ifstream file( filename.c_str(), STDNS ios::in );
  
    if( ! file )
      throw STDNS runtime_error("I/O error");
  
!   file.flags(file.flags() & STDNS ios::skipws);
  
    fContentLength 	= readLong(file);
    fServerPort 		= readLong(file);
Index: cgicc/src/CgiEnvironment.hh
diff -c cgicc/src/CgiEnvironment.hh:1.9 cgicc/src/CgiEnvironment.hh:1.11
*** cgicc/src/CgiEnvironment.hh:1.9	Mon May 10 12:13:16 1999
--- cgicc/src/CgiEnvironment.hh	Fri May 28 12:37:11 1999
***************
*** 1,5 ****
  /*
!  *  $Id: CgiEnvironment.hh,v 1.9 1999/05/10 19:13:16 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: CgiEnvironment.hh,v 1.11 1999/05/28 19:37:11 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __CGI_ENVIRONMENT__
! #define __CGI_ENVIRONMENT__ 1
  
  #include <vector>
  #include <string>
  
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _CGIENVIRONMENT_HH_
! #define _CGIENVIRONMENT_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <vector>
  #include <string>
  
***************
*** 364,370 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 368,372 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _CGIENVIRONMENT_HH_ */
Index: cgicc/src/CgiUtils.cc
diff -c cgicc/src/CgiUtils.cc:1.3 cgicc/src/CgiUtils.cc:1.6
*** cgicc/src/CgiUtils.cc:1.3	Tue May 11 10:03:47 1999
--- cgicc/src/CgiUtils.cc	Tue Jun  1 10:10:18 1999
***************
*** 1,5 ****
  /*
!  *  $Id: CgiUtils.cc,v 1.3 1999/05/11 17:03:47 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: CgiUtils.cc,v 1.6 1999/06/01 17:10:18 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,23 ****
--- 18,27 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
+ 
  #include <stdexcept>
  #include <cstdlib> 	// for getenv, system
  #include <cctype> 	// for toupper
***************
*** 108,113 ****
--- 112,118 ----
  {
    STDNS string result;
    STDNS string::const_iterator iter;
+   char c;
  
    for(iter = src.begin(); iter != src.end(); ++iter) {
      switch(*iter) {
***************
*** 116,122 ****
        break;
      case '%':
        // assume well-formed input
!       result.append(1, hexToChar(*(++iter), *(++iter)));
        break;
      default:
        result.append(1, *iter);
--- 121,129 ----
        break;
      case '%':
        // assume well-formed input
!       // ensure evaluation order for hexToChar
!       c = *++iter;
!       result.append(1, hexToChar(c, *(++iter)));
        break;
      default:
        result.append(1, *iter);
***************
*** 180,186 ****
      delete [] temp;
      throw STDNS runtime_error("I/O error");
    }
!   s = string(temp, dataSize);
    delete [] temp;
    return s;
  }
--- 187,193 ----
      delete [] temp;
      throw STDNS runtime_error("I/O error");
    }
!   s = STDNS string(temp, dataSize);
    delete [] temp;
    return s;
  }
Index: cgicc/src/CgiUtils.hh
diff -c cgicc/src/CgiUtils.hh:1.1 cgicc/src/CgiUtils.hh:1.3
*** cgicc/src/CgiUtils.hh:1.1	Mon Apr 26 16:05:16 1999
--- cgicc/src/CgiUtils.hh	Fri May 28 12:37:12 1999
***************
*** 1,5 ****
  /*
!  *  $Id: CgiUtils.hh,v 1.1 1999/04/26 23:05:16 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: CgiUtils.hh,v 1.3 1999/05/28 19:37:12 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __CGI_UTILS__
! #define __CGI_UTILS__ 1
  
  #include <new>
  #include <string>
  #include <fstream>
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _CGIUTILS_HH_
! #define _CGIUTILS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <new>
  #include <string>
  #include <fstream>
***************
*** 199,202 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 203,206 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _CGIUTILS_HH_ */
Index: cgicc/src/Cgicc.cc
diff -c cgicc/src/Cgicc.cc:1.12 cgicc/src/Cgicc.cc:1.15
*** cgicc/src/Cgicc.cc:1.12	Tue May 11 10:03:47 1999
--- cgicc/src/Cgicc.cc	Tue Jun  1 10:10:18 1999
***************
*** 1,5 ****
  /*
!  *  $Id: Cgicc.cc,v 1.12 1999/05/11 17:03:47 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: Cgicc.cc,v 1.15 1999/06/01 17:10:18 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,23 ****
--- 18,27 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
+ 
  #include <new>
  #include <algorithm>
  #include <functional>
***************
*** 206,213 ****
    LOGLN(s)
  #else
    LOGLN("Cgicc debugging log started.")
! #endif
! #endif
    
    // this can be tweaked for performance
    fFormData.reserve(40);
--- 210,217 ----
    LOGLN(s)
  #else
    LOGLN("Cgicc debugging log started.")
! #endif /* HAVE_STRFTIME */
! #endif /* DEBUG */
    
    // this can be tweaked for performance
    fFormData.reserve(40);
***************
*** 338,354 ****
    // empty the target vector
    result.clear();
  
    if(byName)
      copy_if(fFormData.begin(), 
  	    fFormData.end(), 
! 	    back_inserter(result),
  	    FE_nameCompare(param));
    else
      copy_if(fFormData.begin(), 
  	    fFormData.end(), 
! 	    back_inserter(result),
  	    FE_valueCompare(param));
!   
    return ! result.empty();
  }
  
--- 342,378 ----
    // empty the target vector
    result.clear();
  
+ #ifdef _MSC_VER
+   // Workaround for Microsoft C++ compiler bug, which is unable to instantiate
+   // the copy_if() template functions.
+   if(byName) {
+     STDNS vector<FormEntry>::const_iterator i = fFormData.begin();
+     while(i != fFormData.end()) {
+       if(stringsAreEqual((*i).getName(), param))
+         result.push_back(*i);
+       ++i;
+     }
+   }
+   else {
+     STDNS vector<FormEntry>::const_iterator i = fFormData.begin();
+     while(i != fFormData.end()) {
+       if(stringsAreEqual((*i).getValue(), param))
+         result.push_back(*i);
+       ++i;
+     }
+   }
+ #else
    if(byName)
      copy_if(fFormData.begin(), 
  	    fFormData.end(), 
! 	    STDNS back_inserter(result),
  	    FE_nameCompare(param));
    else
      copy_if(fFormData.begin(), 
  	    fFormData.end(), 
! 	    STDNS back_inserter(result),
  	    FE_valueCompare(param));
! #endif 
    return ! result.empty();
  }
  
Index: cgicc/src/Cgicc.hh
diff -c cgicc/src/Cgicc.hh:1.18 cgicc/src/Cgicc.hh:1.21
*** cgicc/src/Cgicc.hh:1.18	Mon May 10 12:13:17 1999
--- cgicc/src/Cgicc.hh	Tue Jun  1 14:24:28 1999
***************
*** 1,5 ****
  /*
!  *  $Id: Cgicc.hh,v 1.18 1999/05/10 19:13:17 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: Cgicc.hh,v 1.21 1999/06/01 21:24:28 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,35 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __CGICC__
! #define __CGICC__ 1
  
  /*
   * The GNU Cgicc library, by Stephen F. Booth. 
   * The latest version can be found at your closest GNU mirror.
   *
   * Please mail bug reports to <mailto:bug-cgicc@gnu.org>
   *
!  * There is a Cgicc mailing list at <mailto:cgicc@gnu.org>
!  * To subscribe, send a message to <mailto:cgicc-request@gnu.org> with
!  * the word "subscribe" in the subject field.
   *
   * Cgicc is intended to simplify and speed the development of C++
   * CGI(Common Gateway Interface) applications by providing a simple,
--- 18,38 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _CGICC_HH_
! #define _CGICC_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  /*
   * The GNU Cgicc library, by Stephen F. Booth. 
   * The latest version can be found at your closest GNU mirror.
   *
   * Please mail bug reports to <mailto:bug-cgicc@gnu.org>
   *
!  * To subscribe, send a message to <mailto:bug-cgicc-request@gnu.org>
!  * with the word "subscribe" in the subject field.
   *
   * Cgicc is intended to simplify and speed the development of C++
   * CGI(Common Gateway Interface) applications by providing a simple,
***************
*** 303,309 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 306,310 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _CGICC_HH_ */
Index: cgicc/src/FormEntry.cc
diff -c cgicc/src/FormEntry.cc:1.11 cgicc/src/FormEntry.cc:1.12
*** cgicc/src/FormEntry.cc:1.11	Fri May 14 10:57:48 1999
--- cgicc/src/FormEntry.cc	Tue May 25 12:16:44 1999
***************
*** 1,5 ****
  /*
!  *  $Id: FormEntry.cc,v 1.11 1999/05/14 17:57:48 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: FormEntry.cc,v 1.12 1999/05/25 19:16:44 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include <new>
  #include <cstdlib>
Index: cgicc/src/FormEntry.hh
diff -c cgicc/src/FormEntry.hh:1.14 cgicc/src/FormEntry.hh:1.16
*** cgicc/src/FormEntry.hh:1.14	Fri May 14 10:57:48 1999
--- cgicc/src/FormEntry.hh	Fri May 28 12:37:12 1999
***************
*** 1,5 ****
  /*
!  *  $Id: FormEntry.hh,v 1.14 1999/05/14 17:57:48 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: FormEntry.hh,v 1.16 1999/05/28 19:37:12 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __FORM_ENTRY__
! #define __FORM_ENTRY__ 1
  
  #include <iostream>
  #include <string>
  #include <climits>
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _FORMENTRY_HH_
! #define _FORMENTRY_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <iostream>
  #include <string>
  #include <climits>
***************
*** 205,211 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 209,213 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _FORMENTRY_HH_ */
Index: cgicc/src/FormFile.cc
diff -c cgicc/src/FormFile.cc:1.7 cgicc/src/FormFile.cc:1.8
*** cgicc/src/FormFile.cc:1.7	Mon Apr 26 15:42:27 1999
--- cgicc/src/FormFile.cc	Tue May 25 12:16:44 1999
***************
*** 1,5 ****
  /*
!  *  $Id: FormFile.cc,v 1.7 1999/04/26 22:42:27 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: FormFile.cc,v 1.8 1999/05/25 19:16:44 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "FormFile.hh"
  #include "CgiUtils.hh"
Index: cgicc/src/FormFile.hh
diff -c cgicc/src/FormFile.hh:1.12 cgicc/src/FormFile.hh:1.14
*** cgicc/src/FormFile.hh:1.12	Fri May 14 10:57:48 1999
--- cgicc/src/FormFile.hh	Fri May 28 12:37:12 1999
***************
*** 1,5 ****
  /*
!  *  $Id: FormFile.hh,v 1.12 1999/05/14 17:57:48 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: FormFile.hh,v 1.14 1999/05/28 19:37:12 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __FORM_FILE__
! #define __FORM_FILE__ 1
  
  #include <iostream>
  #include <string>
  
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _FORMFILE_HH_
! #define _FORMFILE_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <iostream>
  #include <string>
  
***************
*** 164,170 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 168,172 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _FORMFILE_HH_ */
Index: cgicc/src/HTMLAttributes.cc
diff -c cgicc/src/HTMLAttributes.cc:1.6 cgicc/src/HTMLAttributes.cc:1.7
*** cgicc/src/HTMLAttributes.cc:1.6	Mon Apr 26 15:42:28 1999
--- cgicc/src/HTMLAttributes.cc	Tue May 25 12:16:45 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLAttributes.cc,v 1.6 1999/04/26 22:42:28 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLAttributes.cc,v 1.7 1999/05/25 19:16:45 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLAttributes.hh"
  #include "CgiUtils.hh"
Index: cgicc/src/HTMLAttributes.hh
diff -c cgicc/src/HTMLAttributes.hh:1.6 cgicc/src/HTMLAttributes.hh:1.8
*** cgicc/src/HTMLAttributes.hh:1.6	Mon Apr 26 15:42:28 1999
--- cgicc/src/HTMLAttributes.hh	Fri May 28 12:37:12 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLAttributes.hh,v 1.6 1999/04/26 22:42:28 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLAttributes.hh,v 1.8 1999/05/28 19:37:12 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_ATTRIBUTES__
! #define __HTML_ATTRIBUTES__ 1
  
  #include <string>
  #include <iostream>
  #include <vector>
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLATTRIBUTES_HH_
! #define _HTMLATTRIBUTES_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  #include <iostream>
  #include <vector>
***************
*** 293,299 ****
  { return HTMLAttributeList(HTMLAttribute(name, value)); }
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 297,301 ----
  { return HTMLAttributeList(HTMLAttribute(name, value)); }
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLATTRIBUTES_HH_ */
Index: cgicc/src/HTMLDirLang.cc
diff -c cgicc/src/HTMLDirLang.cc:1.5 cgicc/src/HTMLDirLang.cc:1.6
*** cgicc/src/HTMLDirLang.cc:1.5	Mon Apr 26 15:42:28 1999
--- cgicc/src/HTMLDirLang.cc	Tue May 25 12:16:45 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLDirLang.cc,v 1.5 1999/04/26 22:42:28 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLDirLang.cc,v 1.6 1999/05/25 19:16:45 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLDirLang.hh"
  
Index: cgicc/src/HTMLDirLang.hh
diff -c cgicc/src/HTMLDirLang.hh:1.6 cgicc/src/HTMLDirLang.hh:1.8
*** cgicc/src/HTMLDirLang.hh:1.6	Mon Apr 26 15:42:28 1999
--- cgicc/src/HTMLDirLang.hh	Fri May 28 12:37:13 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLDirLang.hh,v 1.6 1999/04/26 22:42:28 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLDirLang.hh,v 1.8 1999/05/28 19:37:13 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_DIRLANG__
! #define __HTML_DIRLANG__ 1
  
  #include <string>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLDIRLANG_HH_
! #define _HTMLDIRLANG_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "CgiDefs.hh"
***************
*** 90,96 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 94,98 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLDIRLANG_HH_ */
Index: cgicc/src/HTMLElements.cc
diff -c cgicc/src/HTMLElements.cc:1.6 cgicc/src/HTMLElements.cc:1.7
*** cgicc/src/HTMLElements.cc:1.6	Mon Apr 26 15:42:28 1999
--- cgicc/src/HTMLElements.cc	Tue May 25 12:16:45 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLElements.cc,v 1.6 1999/04/26 22:42:28 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLElements.cc,v 1.7 1999/05/25 19:16:45 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLElements.hh"
  
Index: cgicc/src/HTMLElements.hh
diff -c cgicc/src/HTMLElements.hh:1.6 cgicc/src/HTMLElements.hh:1.8
*** cgicc/src/HTMLElements.hh:1.6	Mon Apr 26 15:42:29 1999
--- cgicc/src/HTMLElements.hh	Fri May 28 12:37:13 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLElements.hh,v 1.6 1999/04/26 22:42:29 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLElements.hh,v 1.8 1999/05/28 19:37:13 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_ELEMENTS__
! #define __HTML_ELEMENTS__ 1
  
  #include <string>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLELEMENTS_HH_
! #define _HTMLELEMENTS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "CgiDefs.hh"
***************
*** 237,243 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 241,245 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLELEMENTS_HH_ */
Index: cgicc/src/HTMLForms.cc
diff -c cgicc/src/HTMLForms.cc:1.5 cgicc/src/HTMLForms.cc:1.6
*** cgicc/src/HTMLForms.cc:1.5	Mon Apr 26 15:42:29 1999
--- cgicc/src/HTMLForms.cc	Tue May 25 12:16:46 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLForms.cc,v 1.5 1999/04/26 22:42:29 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLForms.cc,v 1.6 1999/05/25 19:16:46 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLForms.hh"
  
Index: cgicc/src/HTMLForms.hh
diff -c cgicc/src/HTMLForms.hh:1.6 cgicc/src/HTMLForms.hh:1.8
*** cgicc/src/HTMLForms.hh:1.6	Mon Apr 26 15:42:29 1999
--- cgicc/src/HTMLForms.hh	Fri May 28 12:37:13 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLForms.hh,v 1.6 1999/04/26 22:42:29 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLForms.hh,v 1.8 1999/05/28 19:37:13 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_FORMS__
! #define __HTML_FORMS__ 1
  
  #include <string>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLFORMS_HH_
! #define _HTMLFORMS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "CgiDefs.hh"
***************
*** 604,610 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 608,612 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLFORMS_HH_ */
Index: cgicc/src/HTMLFrames.cc
diff -c cgicc/src/HTMLFrames.cc:1.5 cgicc/src/HTMLFrames.cc:1.6
*** cgicc/src/HTMLFrames.cc:1.5	Mon Apr 26 15:42:29 1999
--- cgicc/src/HTMLFrames.cc	Tue May 25 12:16:46 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLFrames.cc,v 1.5 1999/04/26 22:42:29 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLFrames.cc,v 1.6 1999/05/25 19:16:46 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLFrames.hh"
  
Index: cgicc/src/HTMLFrames.hh
diff -c cgicc/src/HTMLFrames.hh:1.6 cgicc/src/HTMLFrames.hh:1.8
*** cgicc/src/HTMLFrames.hh:1.6	Mon Apr 26 15:42:29 1999
--- cgicc/src/HTMLFrames.hh	Fri May 28 12:37:13 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLFrames.hh,v 1.6 1999/04/26 22:42:29 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLFrames.hh,v 1.8 1999/05/28 19:37:13 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_FRAMES__
! #define __HTML_FRAMES__ 1
  
  #include <string>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLFRAMES_HH_
! #define _HTMLFRAMES_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "CgiDefs.hh"
***************
*** 252,258 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 256,260 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLFRAMES_HH_ */
Index: cgicc/src/HTMLGlobal.cc
diff -c cgicc/src/HTMLGlobal.cc:1.5 cgicc/src/HTMLGlobal.cc:1.6
*** cgicc/src/HTMLGlobal.cc:1.5	Mon Apr 26 15:42:30 1999
--- cgicc/src/HTMLGlobal.cc	Tue May 25 12:16:46 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLGlobal.cc,v 1.5 1999/04/26 22:42:30 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLGlobal.cc,v 1.6 1999/05/25 19:16:46 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLGlobal.hh"
  
Index: cgicc/src/HTMLGlobal.hh
diff -c cgicc/src/HTMLGlobal.hh:1.6 cgicc/src/HTMLGlobal.hh:1.8
*** cgicc/src/HTMLGlobal.hh:1.6	Mon Apr 26 15:42:30 1999
--- cgicc/src/HTMLGlobal.hh	Fri May 28 12:37:13 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLGlobal.hh,v 1.6 1999/04/26 22:42:30 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLGlobal.hh,v 1.8 1999/05/28 19:37:13 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_GLOBAL__
! #define __HTML_GLOBAL__ 1
  
  #include <string>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLGLOBAL_HH_
! #define _HTMLGLOBAL_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "CgiDefs.hh"
***************
*** 886,892 ****
  };
  
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 890,894 ----
  };
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLGLOBAL_HH_ */
Index: cgicc/src/HTMLGraphics.cc
diff -c cgicc/src/HTMLGraphics.cc:1.5 cgicc/src/HTMLGraphics.cc:1.6
*** cgicc/src/HTMLGraphics.cc:1.5	Mon Apr 26 15:42:30 1999
--- cgicc/src/HTMLGraphics.cc	Tue May 25 12:16:47 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLGraphics.cc,v 1.5 1999/04/26 22:42:30 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLGraphics.cc,v 1.6 1999/05/25 19:16:47 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLGraphics.hh"
  
Index: cgicc/src/HTMLGraphics.hh
diff -c cgicc/src/HTMLGraphics.hh:1.6 cgicc/src/HTMLGraphics.hh:1.8
*** cgicc/src/HTMLGraphics.hh:1.6	Mon Apr 26 15:42:30 1999
--- cgicc/src/HTMLGraphics.hh	Fri May 28 12:37:14 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLGraphics.hh,v 1.6 1999/04/26 22:42:30 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLGraphics.hh,v 1.8 1999/05/28 19:37:14 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_GRAPHICS__
! #define __HTML_GRAPHICS__ 1
  
  #include <string>
  
  #include "HTMLElements.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLGRAPHICS_HH_
! #define _HTMLGRAPHICS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "HTMLElements.hh"
***************
*** 356,359 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 360,363 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLGRAPHICS_HH_ */
Index: cgicc/src/HTMLLinks.cc
diff -c cgicc/src/HTMLLinks.cc:1.5 cgicc/src/HTMLLinks.cc:1.6
*** cgicc/src/HTMLLinks.cc:1.5	Mon Apr 26 15:42:30 1999
--- cgicc/src/HTMLLinks.cc	Tue May 25 12:16:47 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLLinks.cc,v 1.5 1999/04/26 22:42:30 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLLinks.cc,v 1.6 1999/05/25 19:16:47 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLLinks.hh"
  
Index: cgicc/src/HTMLLinks.hh
diff -c cgicc/src/HTMLLinks.hh:1.6 cgicc/src/HTMLLinks.hh:1.8
*** cgicc/src/HTMLLinks.hh:1.6	Mon Apr 26 15:42:30 1999
--- cgicc/src/HTMLLinks.hh	Fri May 28 12:37:14 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLLinks.hh,v 1.6 1999/04/26 22:42:30 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLLinks.hh,v 1.8 1999/05/28 19:37:14 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_LINKS__
! #define __HTML_LINKS__ 1
  
  #include <string>
  
  #include "HTMLElements.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLLINKS_HH_
! #define _HTMLLINKS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "HTMLElements.hh"
***************
*** 141,144 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 145,148 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLLINKS_HH_ */
Index: cgicc/src/HTMLLists.cc
diff -c cgicc/src/HTMLLists.cc:1.6 cgicc/src/HTMLLists.cc:1.7
*** cgicc/src/HTMLLists.cc:1.6	Mon Apr 26 15:42:30 1999
--- cgicc/src/HTMLLists.cc	Tue May 25 12:16:47 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLLists.cc,v 1.6 1999/04/26 22:42:30 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLLists.cc,v 1.7 1999/05/25 19:16:47 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLLists.hh"
  
Index: cgicc/src/HTMLLists.hh
diff -c cgicc/src/HTMLLists.hh:1.6 cgicc/src/HTMLLists.hh:1.8
*** cgicc/src/HTMLLists.hh:1.6	Mon Apr 26 15:42:31 1999
--- cgicc/src/HTMLLists.hh	Fri May 28 12:37:14 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLLists.hh,v 1.6 1999/04/26 22:42:31 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLLists.hh,v 1.8 1999/05/28 19:37:14 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_LISTS__
! #define __HTML_LISTS__ 1
  
  #include <string>
  
  #include "HTMLElements.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLLISTS_HH_
! #define _HTMLLISTS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "HTMLElements.hh"
***************
*** 395,398 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 399,402 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLLISTS_HH_ */
Index: cgicc/src/HTMLObjects.cc
diff -c cgicc/src/HTMLObjects.cc:1.5 cgicc/src/HTMLObjects.cc:1.6
*** cgicc/src/HTMLObjects.cc:1.5	Mon Apr 26 15:42:31 1999
--- cgicc/src/HTMLObjects.cc	Tue May 25 12:16:48 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLObjects.cc,v 1.5 1999/04/26 22:42:31 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLObjects.cc,v 1.6 1999/05/25 19:16:48 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLObjects.hh"
  
Index: cgicc/src/HTMLObjects.hh
diff -c cgicc/src/HTMLObjects.hh:1.6 cgicc/src/HTMLObjects.hh:1.8
*** cgicc/src/HTMLObjects.hh:1.6	Mon Apr 26 15:42:31 1999
--- cgicc/src/HTMLObjects.hh	Fri May 28 12:37:14 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLObjects.hh,v 1.6 1999/04/26 22:42:31 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLObjects.hh,v 1.8 1999/05/28 19:37:14 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_OBJECTS__
! #define __HTML_OBJECTS__ 1
  
  #include <string>
  
  #include "HTMLElements.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLOBJECTS_HH_
! #define _HTMLOBJECTS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "HTMLElements.hh"
***************
*** 229,232 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 233,236 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLOBJECTS_HH_ */
Index: cgicc/src/HTMLScripts.cc
diff -c cgicc/src/HTMLScripts.cc:1.5 cgicc/src/HTMLScripts.cc:1.6
*** cgicc/src/HTMLScripts.cc:1.5	Mon Apr 26 15:42:31 1999
--- cgicc/src/HTMLScripts.cc	Tue May 25 12:16:48 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLScripts.cc,v 1.5 1999/04/26 22:42:31 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLScripts.cc,v 1.6 1999/05/25 19:16:48 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLScripts.hh"
  
Index: cgicc/src/HTMLScripts.hh
diff -c cgicc/src/HTMLScripts.hh:1.6 cgicc/src/HTMLScripts.hh:1.8
*** cgicc/src/HTMLScripts.hh:1.6	Mon Apr 26 15:42:31 1999
--- cgicc/src/HTMLScripts.hh	Fri May 28 12:37:14 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLScripts.hh,v 1.6 1999/04/26 22:42:31 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLScripts.hh,v 1.8 1999/05/28 19:37:14 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_SCRIPTS__
! #define __HTML_SCRIPTS__ 1
  
  #include <string>
  
  #include "HTMLElements.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLSCRIPTS_HH_
! #define _HTMLSCRIPTS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "HTMLElements.hh"
***************
*** 151,154 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 155,158 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLSCRIPTS_HH_ */
Index: cgicc/src/HTMLStyles.cc
diff -c cgicc/src/HTMLStyles.cc:1.5 cgicc/src/HTMLStyles.cc:1.6
*** cgicc/src/HTMLStyles.cc:1.5	Mon Apr 26 15:42:31 1999
--- cgicc/src/HTMLStyles.cc	Tue May 25 12:16:48 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLStyles.cc,v 1.5 1999/04/26 22:42:31 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLStyles.cc,v 1.6 1999/05/25 19:16:48 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLStyles.hh"
  
Index: cgicc/src/HTMLStyles.hh
diff -c cgicc/src/HTMLStyles.hh:1.6 cgicc/src/HTMLStyles.hh:1.8
*** cgicc/src/HTMLStyles.hh:1.6	Mon Apr 26 15:42:31 1999
--- cgicc/src/HTMLStyles.hh	Fri May 28 12:37:14 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLStyles.hh,v 1.6 1999/04/26 22:42:31 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLStyles.hh,v 1.8 1999/05/28 19:37:14 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_STYLES__
! #define __HTML_STYLES__ 1
  
  #include <string>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLSTYLES_HH_
! #define _HTMLSTYLES_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "CgiDefs.hh"
***************
*** 91,94 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 95,98 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLSTYLES_HH_ */
Index: cgicc/src/HTMLTables.cc
diff -c cgicc/src/HTMLTables.cc:1.5 cgicc/src/HTMLTables.cc:1.6
*** cgicc/src/HTMLTables.cc:1.5	Mon Apr 26 15:42:32 1999
--- cgicc/src/HTMLTables.cc	Tue May 25 12:16:48 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLTables.cc,v 1.5 1999/04/26 22:42:32 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLTables.cc,v 1.6 1999/05/25 19:16:48 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLTables.hh"
  
Index: cgicc/src/HTMLTables.hh
diff -c cgicc/src/HTMLTables.hh:1.6 cgicc/src/HTMLTables.hh:1.8
*** cgicc/src/HTMLTables.hh:1.6	Mon Apr 26 15:42:32 1999
--- cgicc/src/HTMLTables.hh	Fri May 28 12:37:15 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLTables.hh,v 1.6 1999/04/26 22:42:32 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLTables.hh,v 1.8 1999/05/28 19:37:15 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_TABLES__
! #define __HTML_TABLES__ 1
  
  #include <string>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLTABLES_HH_
! #define _HTMLTABLES_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "CgiDefs.hh"
***************
*** 605,608 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 609,612 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLTABLES_HH_ */
Index: cgicc/src/HTMLText.cc
diff -c cgicc/src/HTMLText.cc:1.5 cgicc/src/HTMLText.cc:1.6
*** cgicc/src/HTMLText.cc:1.5	Mon Apr 26 15:42:32 1999
--- cgicc/src/HTMLText.cc	Tue May 25 12:16:49 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLText.cc,v 1.5 1999/04/26 22:42:32 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLText.cc,v 1.6 1999/05/25 19:16:49 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "HTMLText.hh"
  
Index: cgicc/src/HTMLText.hh
diff -c cgicc/src/HTMLText.hh:1.6 cgicc/src/HTMLText.hh:1.8
*** cgicc/src/HTMLText.hh:1.6	Mon Apr 26 15:42:32 1999
--- cgicc/src/HTMLText.hh	Fri May 28 12:37:15 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTMLText.hh,v 1.6 1999/04/26 22:42:32 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTMLText.hh,v 1.8 1999/05/28 19:37:15 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTML_TEXT__
! #define __HTML_TEXT__ 1
  
  #include <string>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTMLTEXT_HH_
! #define _HTMLTEXT_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "CgiDefs.hh"
***************
*** 1136,1139 ****
  
  CGICC_END_NAMESPACE
  
! #endif
--- 1140,1143 ----
  
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTMLTEXT_HH_ */
Index: cgicc/src/HTTPHeaders.cc
diff -c cgicc/src/HTTPHeaders.cc:1.7 cgicc/src/HTTPHeaders.cc:1.9
*** cgicc/src/HTTPHeaders.cc:1.7	Mon Apr 26 15:42:32 1999
--- cgicc/src/HTTPHeaders.cc	Tue Jun  1 10:10:19 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTTPHeaders.cc,v 1.7 1999/04/26 22:42:32 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTTPHeaders.cc,v 1.9 1999/06/01 17:10:19 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,23 ****
--- 18,27 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
+ 
  #include "HTTPHeaders.hh"
  
  // ============================================================
***************
*** 119,125 ****
    if(fSecure == true)
      out << " secure";
    
!   out << endl;
  }
  
  // ============================================================
--- 123,129 ----
    if(fSecure == true)
      out << " secure";
    
!   out << STDNS endl;
  }
  
  // ============================================================
***************
*** 152,158 ****
  void 
  CGICCNS HTTPContentHeader::render(STDNS ostream& out)	const
  {
!   out << "Content-Type: " << getData() << endl << endl;
  }
  
  // ============================================================
--- 156,162 ----
  void 
  CGICCNS HTTPContentHeader::render(STDNS ostream& out)	const
  {
!   out << "Content-Type: " << getData() << STDNS endl << STDNS endl;
  }
  
  // ============================================================
***************
*** 168,174 ****
  void 
  CGICCNS HTTPRedirectHeader::render(STDNS ostream& out) 	const
  {
!   out << "Location: " << getData() << endl << endl;
  }
  
  // ============================================================
--- 172,178 ----
  void 
  CGICCNS HTTPRedirectHeader::render(STDNS ostream& out) 	const
  {
!   out << "Location: " << getData() << STDNS endl << STDNS endl;
  }
  
  // ============================================================
***************
*** 191,197 ****
  void 
  CGICCNS HTTPStatusHeader::render(STDNS ostream& out) 	const
  {
!   out << "Status: " << getStatusCode() << ' ' << getData() << endl << endl;
  }
  
  // ============================================================
--- 195,202 ----
  void 
  CGICCNS HTTPStatusHeader::render(STDNS ostream& out) 	const
  {
!   out << "Status: " << getStatusCode() << ' ' << getData() 
!       << STDNS endl << STDNS endl;
  }
  
  // ============================================================
***************
*** 207,213 ****
  void 
  CGICCNS HTTPNPHeader::render(STDNS ostream& out) 	const
  {
!   out << getData() << endl << endl;
  }
  
  // ============================================================
--- 212,218 ----
  void 
  CGICCNS HTTPNPHeader::render(STDNS ostream& out) 	const
  {
!   out << getData() << STDNS endl << STDNS endl;
  }
  
  // ============================================================
Index: cgicc/src/HTTPHeaders.hh
diff -c cgicc/src/HTTPHeaders.hh:1.7 cgicc/src/HTTPHeaders.hh:1.9
*** cgicc/src/HTTPHeaders.hh:1.7	Mon Apr 26 15:42:32 1999
--- cgicc/src/HTTPHeaders.hh	Fri May 28 12:37:15 1999
***************
*** 1,5 ****
  /*
!  *  $Id: HTTPHeaders.hh,v 1.7 1999/04/26 22:42:32 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: HTTPHeaders.hh,v 1.9 1999/05/28 19:37:15 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __HTTP_HEADERS__
! #define __HTTP_HEADERS__ 1
  
  #include <string>
  
  #include "MStreamable.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _HTTPHEADERS_HH_
! #define _HTTPHEADERS_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <string>
  
  #include "MStreamable.hh"
***************
*** 483,489 ****
  };
    
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 487,491 ----
  };
    
  CGICC_END_NAMESPACE
  
! #endif /* ! _HTTPHEADERS_HH_ */
Index: cgicc/src/MStreamable.cc
diff -c cgicc/src/MStreamable.cc:1.5 cgicc/src/MStreamable.cc:1.6
*** cgicc/src/MStreamable.cc:1.5	Mon Apr 26 15:42:34 1999
--- cgicc/src/MStreamable.cc	Tue May 25 12:16:49 1999
***************
*** 1,5 ****
  /*
!  *  $Id: MStreamable.cc,v 1.5 1999/04/26 22:42:34 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: MStreamable.cc,v 1.6 1999/05/25 19:16:49 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 17,22 ****
--- 17,26 ----
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
+ 
+ #ifdef __GNUG__
+ #pragma implementation
+ #endif
  
  #include "MStreamable.hh"
  
Index: cgicc/src/MStreamable.hh
diff -c cgicc/src/MStreamable.hh:1.5 cgicc/src/MStreamable.hh:1.7
*** cgicc/src/MStreamable.hh:1.5	Mon Apr 26 15:42:34 1999
--- cgicc/src/MStreamable.hh	Fri May 28 12:37:15 1999
***************
*** 1,5 ****
  /*
!  *  $Id: MStreamable.hh,v 1.5 1999/04/26 22:42:34 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
--- 1,5 ----
  /*
!  *  $Id: MStreamable.hh,v 1.7 1999/05/28 19:37:15 sbooth Exp $
   *
   *  Copyright (C) 1996, 1997, 1998, 1999 Stephen F. Booth
   *
***************
*** 18,26 ****
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef __MSTREAMABLE__
! #define __MSTREAMABLE__ 1
  
  #include <iostream>
  
  #include "CgiDefs.hh"
--- 18,30 ----
   *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
! #ifndef _MSTREAMABLE_HH_
! #define _MSTREAMABLE_HH_ 1
  
+ #ifdef __GNUG__
+ #pragma interface
+ #endif
+ 
  #include <iostream>
  
  #include "CgiDefs.hh"
***************
*** 50,56 ****
  };
    
  CGICC_END_NAMESPACE
- 
- #endif
  
! //EOF
--- 54,58 ----
  };
    
  CGICC_END_NAMESPACE
  
! #endif /* ! _MSTREAMABLE_HH_ */
Index: cgicc/src/Makefile.am
diff -c cgicc/src/Makefile.am:1.8 cgicc/src/Makefile.am:1.9
*** cgicc/src/Makefile.am:1.8	Mon May 10 12:13:17 1999
--- cgicc/src/Makefile.am	Mon May 31 10:04:35 1999
***************
*** 1,4 ****
! ## $Id: Makefile.am,v 1.8 1999/05/10 19:13:17 sbooth Exp $
  
  CLEANFILES = *~
  
--- 1,4 ----
! ## $Id: Makefile.am,v 1.9 1999/05/31 17:04:35 sbooth Exp $
  
  CLEANFILES = *~
  
***************
*** 9,15 ****
  HTMLGraphics.cc HTMLLinks.cc HTMLLists.cc HTMLObjects.cc		\
  HTMLScripts.cc HTMLStyles.cc HTMLTables.cc HTMLText.cc HTTPHeaders.cc	\
  MStreamable.cc
! libcgicc_la_LDFLAGS = -version-info 0:0:0
  
  pkginclude_HEADERS = Cgicc.hh CgiDefs.hh CgiEnvironment.hh CgiUtils.hh	\
  FormEntry.hh FormFile.hh HTMLAttributes.hh HTMLClasses.hh		\
--- 9,15 ----
  HTMLGraphics.cc HTMLLinks.cc HTMLLists.cc HTMLObjects.cc		\
  HTMLScripts.cc HTMLStyles.cc HTMLTables.cc HTMLText.cc HTTPHeaders.cc	\
  MStreamable.cc
! libcgicc_la_LDFLAGS = -version-info 0:1:0
  
  pkginclude_HEADERS = Cgicc.hh CgiDefs.hh CgiEnvironment.hh CgiUtils.hh	\
  FormEntry.hh FormFile.hh HTMLAttributes.hh HTMLClasses.hh		\
